/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"bytes"
	"encoding/json"
	"fmt"
	"time"
)

// checks if the Identity type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Identity{}

// Identity struct for Identity
type Identity struct {
	Type                       IdentityType      `json:"type"`
	Upn                        NullableString    `json:"upn,omitempty"`
	DisplayName                string            `json:"displayName"`
	FirstName                  NullableString    `json:"firstName,omitempty"`
	LastName                   NullableString    `json:"lastName,omitempty"`
	BirthDate                  NullableTime      `json:"birthDate,omitempty"`
	PersonId                   NullableString    `json:"personId,omitempty"`
	CernPersonId               NullableString    `json:"cernPersonId,omitempty"`
	SupervisorId               NullableString    `json:"supervisorId,omitempty"`
	DirectResponsibleId        NullableString    `json:"directResponsibleId,omitempty"`
	Source                     NullableString    `json:"source,omitempty"`
	Unconfirmed                bool              `json:"unconfirmed"`
	UnconfirmedEmail           NullableString    `json:"unconfirmedEmail,omitempty"`
	PrimaryAccountId           NullableString    `json:"primaryAccountId,omitempty"`
	Uid                        NullableInt32     `json:"uid,omitempty"`
	Gid                        NullableInt32     `json:"gid,omitempty"`
	Building                   NullableString    `json:"building,omitempty"`
	Floor                      NullableString    `json:"floor,omitempty"`
	Room                       NullableString    `json:"room,omitempty"`
	ActiveUser                 *bool             `json:"activeUser,omitempty"`
	CernClass                  NullableString    `json:"cernClass,omitempty"`
	StartClass                 NullableTime      `json:"startClass,omitempty"`
	EndClass                   NullableTime      `json:"endClass,omitempty"`
	CernDepartment             NullableString    `json:"cernDepartment,omitempty"`
	CernGroup                  NullableString    `json:"cernGroup,omitempty"`
	CernSection                NullableString    `json:"cernSection,omitempty"`
	InstituteName              NullableString    `json:"instituteName,omitempty"`
	InstituteAbbreviation      NullableString    `json:"instituteAbbreviation,omitempty"`
	ComputingRulesAcceptedFlag *bool             `json:"computingRulesAcceptedFlag,omitempty"`
	ComputingRulesAccepted     NullableTime      `json:"computingRulesAccepted,omitempty"`
	ComputingRulesValidUntil   NullableTime      `json:"computingRulesValidUntil,omitempty"`
	PreferredCernLanguage      NullableString    `json:"preferredCernLanguage,omitempty"`
	Telephone1                 NullableString    `json:"telephone1,omitempty"`
	Telephone2                 NullableString    `json:"telephone2,omitempty"`
	PortablePhone              NullableString    `json:"portablePhone,omitempty"`
	EdhAuthPwdExpiry           NullableTime      `json:"edhAuthPwdExpiry,omitempty"`
	EduPersonUniqueID          NullableString    `json:"eduPersonUniqueID,omitempty"`
	Orcid                      NullableString    `json:"orcid,omitempty"`
	Description                NullableString    `json:"description,omitempty"`
	HrEmail                    NullableString    `json:"hrEmail,omitempty"`
	AtCern                     *bool             `json:"atCern,omitempty"`
	PostOfficeBox              NullableString    `json:"postOfficeBox,omitempty"`
	Supervisor                 *Identity         `json:"supervisor,omitempty"`
	ExternalEmail              NullableString    `json:"externalEmail,omitempty"`
	PrimaryAccountEmail        NullableString    `json:"primaryAccountEmail,omitempty"`
	ResourceCategory           *ResourceCategory `json:"resourceCategory,omitempty"`
	Reassignable               *bool             `json:"reassignable,omitempty"`
	AutoReassign               *bool             `json:"autoReassign,omitempty"`
	// Deprecated
	PendingAction    *bool          `json:"pendingAction,omitempty"`
	Disabled         *bool          `json:"disabled,omitempty"`
	Blocked          *bool          `json:"blocked,omitempty"`
	SecurityIssues   *bool          `json:"securityIssues,omitempty"`
	BlockingReason   NullableString `json:"blockingReason,omitempty"`
	BlockingTime     NullableTime   `json:"blockingTime,omitempty"`
	BlockingDeadline NullableTime   `json:"blockingDeadline,omitempty"`
	ArchiveDeadline  NullableTime   `json:"archiveDeadline,omitempty"`
	DeleteDeadline   NullableTime   `json:"deleteDeadline,omitempty"`
	// Deprecated
	ExpirationDeadline  NullableTime   `json:"expirationDeadline,omitempty"`
	OwnerId             NullableString `json:"ownerId,omitempty"`
	InternalState       *ResourceState `json:"internalState,omitempty"`
	State               *ResourceState `json:"state,omitempty"`
	LastStateChangeTime NullableTime   `json:"lastStateChangeTime,omitempty"`
	ValidityLimit       NullableTime   `json:"validityLimit,omitempty"`
	Id                  NullableString `json:"id,omitempty"`
	CreationTime        *time.Time     `json:"creationTime,omitempty"`
}

type _Identity Identity

// NewIdentity instantiates a new Identity object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewIdentity(type_ IdentityType, displayName string, unconfirmed bool) *Identity {
	this := Identity{}
	this.Type = type_
	this.DisplayName = displayName
	this.Unconfirmed = unconfirmed
	return &this
}

// NewIdentityWithDefaults instantiates a new Identity object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewIdentityWithDefaults() *Identity {
	this := Identity{}
	return &this
}

// GetType returns the Type field value
func (o *Identity) GetType() IdentityType {
	if o == nil {
		var ret IdentityType
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *Identity) GetTypeOk() (*IdentityType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *Identity) SetType(v IdentityType) {
	o.Type = v
}

// GetUpn returns the Upn field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetUpn() string {
	if o == nil || IsNil(o.Upn.Get()) {
		var ret string
		return ret
	}
	return *o.Upn.Get()
}

// GetUpnOk returns a tuple with the Upn field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetUpnOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Upn.Get(), o.Upn.IsSet()
}

// HasUpn returns a boolean if a field has been set.
func (o *Identity) HasUpn() bool {
	if o != nil && o.Upn.IsSet() {
		return true
	}

	return false
}

// SetUpn gets a reference to the given NullableString and assigns it to the Upn field.
func (o *Identity) SetUpn(v string) {
	o.Upn.Set(&v)
}

// SetUpnNil sets the value for Upn to be an explicit nil
func (o *Identity) SetUpnNil() {
	o.Upn.Set(nil)
}

// UnsetUpn ensures that no value is present for Upn, not even an explicit nil
func (o *Identity) UnsetUpn() {
	o.Upn.Unset()
}

// GetDisplayName returns the DisplayName field value
func (o *Identity) GetDisplayName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DisplayName
}

// GetDisplayNameOk returns a tuple with the DisplayName field value
// and a boolean to check if the value has been set.
func (o *Identity) GetDisplayNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DisplayName, true
}

// SetDisplayName sets field value
func (o *Identity) SetDisplayName(v string) {
	o.DisplayName = v
}

// GetFirstName returns the FirstName field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetFirstName() string {
	if o == nil || IsNil(o.FirstName.Get()) {
		var ret string
		return ret
	}
	return *o.FirstName.Get()
}

// GetFirstNameOk returns a tuple with the FirstName field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetFirstNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.FirstName.Get(), o.FirstName.IsSet()
}

// HasFirstName returns a boolean if a field has been set.
func (o *Identity) HasFirstName() bool {
	if o != nil && o.FirstName.IsSet() {
		return true
	}

	return false
}

// SetFirstName gets a reference to the given NullableString and assigns it to the FirstName field.
func (o *Identity) SetFirstName(v string) {
	o.FirstName.Set(&v)
}

// SetFirstNameNil sets the value for FirstName to be an explicit nil
func (o *Identity) SetFirstNameNil() {
	o.FirstName.Set(nil)
}

// UnsetFirstName ensures that no value is present for FirstName, not even an explicit nil
func (o *Identity) UnsetFirstName() {
	o.FirstName.Unset()
}

// GetLastName returns the LastName field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetLastName() string {
	if o == nil || IsNil(o.LastName.Get()) {
		var ret string
		return ret
	}
	return *o.LastName.Get()
}

// GetLastNameOk returns a tuple with the LastName field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetLastNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.LastName.Get(), o.LastName.IsSet()
}

// HasLastName returns a boolean if a field has been set.
func (o *Identity) HasLastName() bool {
	if o != nil && o.LastName.IsSet() {
		return true
	}

	return false
}

// SetLastName gets a reference to the given NullableString and assigns it to the LastName field.
func (o *Identity) SetLastName(v string) {
	o.LastName.Set(&v)
}

// SetLastNameNil sets the value for LastName to be an explicit nil
func (o *Identity) SetLastNameNil() {
	o.LastName.Set(nil)
}

// UnsetLastName ensures that no value is present for LastName, not even an explicit nil
func (o *Identity) UnsetLastName() {
	o.LastName.Unset()
}

// GetBirthDate returns the BirthDate field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetBirthDate() time.Time {
	if o == nil || IsNil(o.BirthDate.Get()) {
		var ret time.Time
		return ret
	}
	return *o.BirthDate.Get()
}

// GetBirthDateOk returns a tuple with the BirthDate field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetBirthDateOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.BirthDate.Get(), o.BirthDate.IsSet()
}

// HasBirthDate returns a boolean if a field has been set.
func (o *Identity) HasBirthDate() bool {
	if o != nil && o.BirthDate.IsSet() {
		return true
	}

	return false
}

// SetBirthDate gets a reference to the given NullableTime and assigns it to the BirthDate field.
func (o *Identity) SetBirthDate(v time.Time) {
	o.BirthDate.Set(&v)
}

// SetBirthDateNil sets the value for BirthDate to be an explicit nil
func (o *Identity) SetBirthDateNil() {
	o.BirthDate.Set(nil)
}

// UnsetBirthDate ensures that no value is present for BirthDate, not even an explicit nil
func (o *Identity) UnsetBirthDate() {
	o.BirthDate.Unset()
}

// GetPersonId returns the PersonId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetPersonId() string {
	if o == nil || IsNil(o.PersonId.Get()) {
		var ret string
		return ret
	}
	return *o.PersonId.Get()
}

// GetPersonIdOk returns a tuple with the PersonId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetPersonIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.PersonId.Get(), o.PersonId.IsSet()
}

// HasPersonId returns a boolean if a field has been set.
func (o *Identity) HasPersonId() bool {
	if o != nil && o.PersonId.IsSet() {
		return true
	}

	return false
}

// SetPersonId gets a reference to the given NullableString and assigns it to the PersonId field.
func (o *Identity) SetPersonId(v string) {
	o.PersonId.Set(&v)
}

// SetPersonIdNil sets the value for PersonId to be an explicit nil
func (o *Identity) SetPersonIdNil() {
	o.PersonId.Set(nil)
}

// UnsetPersonId ensures that no value is present for PersonId, not even an explicit nil
func (o *Identity) UnsetPersonId() {
	o.PersonId.Unset()
}

// GetCernPersonId returns the CernPersonId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetCernPersonId() string {
	if o == nil || IsNil(o.CernPersonId.Get()) {
		var ret string
		return ret
	}
	return *o.CernPersonId.Get()
}

// GetCernPersonIdOk returns a tuple with the CernPersonId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetCernPersonIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.CernPersonId.Get(), o.CernPersonId.IsSet()
}

// HasCernPersonId returns a boolean if a field has been set.
func (o *Identity) HasCernPersonId() bool {
	if o != nil && o.CernPersonId.IsSet() {
		return true
	}

	return false
}

// SetCernPersonId gets a reference to the given NullableString and assigns it to the CernPersonId field.
func (o *Identity) SetCernPersonId(v string) {
	o.CernPersonId.Set(&v)
}

// SetCernPersonIdNil sets the value for CernPersonId to be an explicit nil
func (o *Identity) SetCernPersonIdNil() {
	o.CernPersonId.Set(nil)
}

// UnsetCernPersonId ensures that no value is present for CernPersonId, not even an explicit nil
func (o *Identity) UnsetCernPersonId() {
	o.CernPersonId.Unset()
}

// GetSupervisorId returns the SupervisorId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetSupervisorId() string {
	if o == nil || IsNil(o.SupervisorId.Get()) {
		var ret string
		return ret
	}
	return *o.SupervisorId.Get()
}

// GetSupervisorIdOk returns a tuple with the SupervisorId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetSupervisorIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.SupervisorId.Get(), o.SupervisorId.IsSet()
}

// HasSupervisorId returns a boolean if a field has been set.
func (o *Identity) HasSupervisorId() bool {
	if o != nil && o.SupervisorId.IsSet() {
		return true
	}

	return false
}

// SetSupervisorId gets a reference to the given NullableString and assigns it to the SupervisorId field.
func (o *Identity) SetSupervisorId(v string) {
	o.SupervisorId.Set(&v)
}

// SetSupervisorIdNil sets the value for SupervisorId to be an explicit nil
func (o *Identity) SetSupervisorIdNil() {
	o.SupervisorId.Set(nil)
}

// UnsetSupervisorId ensures that no value is present for SupervisorId, not even an explicit nil
func (o *Identity) UnsetSupervisorId() {
	o.SupervisorId.Unset()
}

// GetDirectResponsibleId returns the DirectResponsibleId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetDirectResponsibleId() string {
	if o == nil || IsNil(o.DirectResponsibleId.Get()) {
		var ret string
		return ret
	}
	return *o.DirectResponsibleId.Get()
}

// GetDirectResponsibleIdOk returns a tuple with the DirectResponsibleId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetDirectResponsibleIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.DirectResponsibleId.Get(), o.DirectResponsibleId.IsSet()
}

// HasDirectResponsibleId returns a boolean if a field has been set.
func (o *Identity) HasDirectResponsibleId() bool {
	if o != nil && o.DirectResponsibleId.IsSet() {
		return true
	}

	return false
}

// SetDirectResponsibleId gets a reference to the given NullableString and assigns it to the DirectResponsibleId field.
func (o *Identity) SetDirectResponsibleId(v string) {
	o.DirectResponsibleId.Set(&v)
}

// SetDirectResponsibleIdNil sets the value for DirectResponsibleId to be an explicit nil
func (o *Identity) SetDirectResponsibleIdNil() {
	o.DirectResponsibleId.Set(nil)
}

// UnsetDirectResponsibleId ensures that no value is present for DirectResponsibleId, not even an explicit nil
func (o *Identity) UnsetDirectResponsibleId() {
	o.DirectResponsibleId.Unset()
}

// GetSource returns the Source field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetSource() string {
	if o == nil || IsNil(o.Source.Get()) {
		var ret string
		return ret
	}
	return *o.Source.Get()
}

// GetSourceOk returns a tuple with the Source field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetSourceOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Source.Get(), o.Source.IsSet()
}

// HasSource returns a boolean if a field has been set.
func (o *Identity) HasSource() bool {
	if o != nil && o.Source.IsSet() {
		return true
	}

	return false
}

// SetSource gets a reference to the given NullableString and assigns it to the Source field.
func (o *Identity) SetSource(v string) {
	o.Source.Set(&v)
}

// SetSourceNil sets the value for Source to be an explicit nil
func (o *Identity) SetSourceNil() {
	o.Source.Set(nil)
}

// UnsetSource ensures that no value is present for Source, not even an explicit nil
func (o *Identity) UnsetSource() {
	o.Source.Unset()
}

// GetUnconfirmed returns the Unconfirmed field value
func (o *Identity) GetUnconfirmed() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Unconfirmed
}

// GetUnconfirmedOk returns a tuple with the Unconfirmed field value
// and a boolean to check if the value has been set.
func (o *Identity) GetUnconfirmedOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Unconfirmed, true
}

// SetUnconfirmed sets field value
func (o *Identity) SetUnconfirmed(v bool) {
	o.Unconfirmed = v
}

// GetUnconfirmedEmail returns the UnconfirmedEmail field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetUnconfirmedEmail() string {
	if o == nil || IsNil(o.UnconfirmedEmail.Get()) {
		var ret string
		return ret
	}
	return *o.UnconfirmedEmail.Get()
}

// GetUnconfirmedEmailOk returns a tuple with the UnconfirmedEmail field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetUnconfirmedEmailOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.UnconfirmedEmail.Get(), o.UnconfirmedEmail.IsSet()
}

// HasUnconfirmedEmail returns a boolean if a field has been set.
func (o *Identity) HasUnconfirmedEmail() bool {
	if o != nil && o.UnconfirmedEmail.IsSet() {
		return true
	}

	return false
}

// SetUnconfirmedEmail gets a reference to the given NullableString and assigns it to the UnconfirmedEmail field.
func (o *Identity) SetUnconfirmedEmail(v string) {
	o.UnconfirmedEmail.Set(&v)
}

// SetUnconfirmedEmailNil sets the value for UnconfirmedEmail to be an explicit nil
func (o *Identity) SetUnconfirmedEmailNil() {
	o.UnconfirmedEmail.Set(nil)
}

// UnsetUnconfirmedEmail ensures that no value is present for UnconfirmedEmail, not even an explicit nil
func (o *Identity) UnsetUnconfirmedEmail() {
	o.UnconfirmedEmail.Unset()
}

// GetPrimaryAccountId returns the PrimaryAccountId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetPrimaryAccountId() string {
	if o == nil || IsNil(o.PrimaryAccountId.Get()) {
		var ret string
		return ret
	}
	return *o.PrimaryAccountId.Get()
}

// GetPrimaryAccountIdOk returns a tuple with the PrimaryAccountId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetPrimaryAccountIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.PrimaryAccountId.Get(), o.PrimaryAccountId.IsSet()
}

// HasPrimaryAccountId returns a boolean if a field has been set.
func (o *Identity) HasPrimaryAccountId() bool {
	if o != nil && o.PrimaryAccountId.IsSet() {
		return true
	}

	return false
}

// SetPrimaryAccountId gets a reference to the given NullableString and assigns it to the PrimaryAccountId field.
func (o *Identity) SetPrimaryAccountId(v string) {
	o.PrimaryAccountId.Set(&v)
}

// SetPrimaryAccountIdNil sets the value for PrimaryAccountId to be an explicit nil
func (o *Identity) SetPrimaryAccountIdNil() {
	o.PrimaryAccountId.Set(nil)
}

// UnsetPrimaryAccountId ensures that no value is present for PrimaryAccountId, not even an explicit nil
func (o *Identity) UnsetPrimaryAccountId() {
	o.PrimaryAccountId.Unset()
}

// GetUid returns the Uid field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetUid() int32 {
	if o == nil || IsNil(o.Uid.Get()) {
		var ret int32
		return ret
	}
	return *o.Uid.Get()
}

// GetUidOk returns a tuple with the Uid field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetUidOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.Uid.Get(), o.Uid.IsSet()
}

// HasUid returns a boolean if a field has been set.
func (o *Identity) HasUid() bool {
	if o != nil && o.Uid.IsSet() {
		return true
	}

	return false
}

// SetUid gets a reference to the given NullableInt32 and assigns it to the Uid field.
func (o *Identity) SetUid(v int32) {
	o.Uid.Set(&v)
}

// SetUidNil sets the value for Uid to be an explicit nil
func (o *Identity) SetUidNil() {
	o.Uid.Set(nil)
}

// UnsetUid ensures that no value is present for Uid, not even an explicit nil
func (o *Identity) UnsetUid() {
	o.Uid.Unset()
}

// GetGid returns the Gid field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetGid() int32 {
	if o == nil || IsNil(o.Gid.Get()) {
		var ret int32
		return ret
	}
	return *o.Gid.Get()
}

// GetGidOk returns a tuple with the Gid field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetGidOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.Gid.Get(), o.Gid.IsSet()
}

// HasGid returns a boolean if a field has been set.
func (o *Identity) HasGid() bool {
	if o != nil && o.Gid.IsSet() {
		return true
	}

	return false
}

// SetGid gets a reference to the given NullableInt32 and assigns it to the Gid field.
func (o *Identity) SetGid(v int32) {
	o.Gid.Set(&v)
}

// SetGidNil sets the value for Gid to be an explicit nil
func (o *Identity) SetGidNil() {
	o.Gid.Set(nil)
}

// UnsetGid ensures that no value is present for Gid, not even an explicit nil
func (o *Identity) UnsetGid() {
	o.Gid.Unset()
}

// GetBuilding returns the Building field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetBuilding() string {
	if o == nil || IsNil(o.Building.Get()) {
		var ret string
		return ret
	}
	return *o.Building.Get()
}

// GetBuildingOk returns a tuple with the Building field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetBuildingOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Building.Get(), o.Building.IsSet()
}

// HasBuilding returns a boolean if a field has been set.
func (o *Identity) HasBuilding() bool {
	if o != nil && o.Building.IsSet() {
		return true
	}

	return false
}

// SetBuilding gets a reference to the given NullableString and assigns it to the Building field.
func (o *Identity) SetBuilding(v string) {
	o.Building.Set(&v)
}

// SetBuildingNil sets the value for Building to be an explicit nil
func (o *Identity) SetBuildingNil() {
	o.Building.Set(nil)
}

// UnsetBuilding ensures that no value is present for Building, not even an explicit nil
func (o *Identity) UnsetBuilding() {
	o.Building.Unset()
}

// GetFloor returns the Floor field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetFloor() string {
	if o == nil || IsNil(o.Floor.Get()) {
		var ret string
		return ret
	}
	return *o.Floor.Get()
}

// GetFloorOk returns a tuple with the Floor field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetFloorOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Floor.Get(), o.Floor.IsSet()
}

// HasFloor returns a boolean if a field has been set.
func (o *Identity) HasFloor() bool {
	if o != nil && o.Floor.IsSet() {
		return true
	}

	return false
}

// SetFloor gets a reference to the given NullableString and assigns it to the Floor field.
func (o *Identity) SetFloor(v string) {
	o.Floor.Set(&v)
}

// SetFloorNil sets the value for Floor to be an explicit nil
func (o *Identity) SetFloorNil() {
	o.Floor.Set(nil)
}

// UnsetFloor ensures that no value is present for Floor, not even an explicit nil
func (o *Identity) UnsetFloor() {
	o.Floor.Unset()
}

// GetRoom returns the Room field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetRoom() string {
	if o == nil || IsNil(o.Room.Get()) {
		var ret string
		return ret
	}
	return *o.Room.Get()
}

// GetRoomOk returns a tuple with the Room field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetRoomOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Room.Get(), o.Room.IsSet()
}

// HasRoom returns a boolean if a field has been set.
func (o *Identity) HasRoom() bool {
	if o != nil && o.Room.IsSet() {
		return true
	}

	return false
}

// SetRoom gets a reference to the given NullableString and assigns it to the Room field.
func (o *Identity) SetRoom(v string) {
	o.Room.Set(&v)
}

// SetRoomNil sets the value for Room to be an explicit nil
func (o *Identity) SetRoomNil() {
	o.Room.Set(nil)
}

// UnsetRoom ensures that no value is present for Room, not even an explicit nil
func (o *Identity) UnsetRoom() {
	o.Room.Unset()
}

// GetActiveUser returns the ActiveUser field value if set, zero value otherwise.
func (o *Identity) GetActiveUser() bool {
	if o == nil || IsNil(o.ActiveUser) {
		var ret bool
		return ret
	}
	return *o.ActiveUser
}

// GetActiveUserOk returns a tuple with the ActiveUser field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Identity) GetActiveUserOk() (*bool, bool) {
	if o == nil || IsNil(o.ActiveUser) {
		return nil, false
	}
	return o.ActiveUser, true
}

// HasActiveUser returns a boolean if a field has been set.
func (o *Identity) HasActiveUser() bool {
	if o != nil && !IsNil(o.ActiveUser) {
		return true
	}

	return false
}

// SetActiveUser gets a reference to the given bool and assigns it to the ActiveUser field.
func (o *Identity) SetActiveUser(v bool) {
	o.ActiveUser = &v
}

// GetCernClass returns the CernClass field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetCernClass() string {
	if o == nil || IsNil(o.CernClass.Get()) {
		var ret string
		return ret
	}
	return *o.CernClass.Get()
}

// GetCernClassOk returns a tuple with the CernClass field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetCernClassOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.CernClass.Get(), o.CernClass.IsSet()
}

// HasCernClass returns a boolean if a field has been set.
func (o *Identity) HasCernClass() bool {
	if o != nil && o.CernClass.IsSet() {
		return true
	}

	return false
}

// SetCernClass gets a reference to the given NullableString and assigns it to the CernClass field.
func (o *Identity) SetCernClass(v string) {
	o.CernClass.Set(&v)
}

// SetCernClassNil sets the value for CernClass to be an explicit nil
func (o *Identity) SetCernClassNil() {
	o.CernClass.Set(nil)
}

// UnsetCernClass ensures that no value is present for CernClass, not even an explicit nil
func (o *Identity) UnsetCernClass() {
	o.CernClass.Unset()
}

// GetStartClass returns the StartClass field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetStartClass() time.Time {
	if o == nil || IsNil(o.StartClass.Get()) {
		var ret time.Time
		return ret
	}
	return *o.StartClass.Get()
}

// GetStartClassOk returns a tuple with the StartClass field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetStartClassOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.StartClass.Get(), o.StartClass.IsSet()
}

// HasStartClass returns a boolean if a field has been set.
func (o *Identity) HasStartClass() bool {
	if o != nil && o.StartClass.IsSet() {
		return true
	}

	return false
}

// SetStartClass gets a reference to the given NullableTime and assigns it to the StartClass field.
func (o *Identity) SetStartClass(v time.Time) {
	o.StartClass.Set(&v)
}

// SetStartClassNil sets the value for StartClass to be an explicit nil
func (o *Identity) SetStartClassNil() {
	o.StartClass.Set(nil)
}

// UnsetStartClass ensures that no value is present for StartClass, not even an explicit nil
func (o *Identity) UnsetStartClass() {
	o.StartClass.Unset()
}

// GetEndClass returns the EndClass field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetEndClass() time.Time {
	if o == nil || IsNil(o.EndClass.Get()) {
		var ret time.Time
		return ret
	}
	return *o.EndClass.Get()
}

// GetEndClassOk returns a tuple with the EndClass field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetEndClassOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.EndClass.Get(), o.EndClass.IsSet()
}

// HasEndClass returns a boolean if a field has been set.
func (o *Identity) HasEndClass() bool {
	if o != nil && o.EndClass.IsSet() {
		return true
	}

	return false
}

// SetEndClass gets a reference to the given NullableTime and assigns it to the EndClass field.
func (o *Identity) SetEndClass(v time.Time) {
	o.EndClass.Set(&v)
}

// SetEndClassNil sets the value for EndClass to be an explicit nil
func (o *Identity) SetEndClassNil() {
	o.EndClass.Set(nil)
}

// UnsetEndClass ensures that no value is present for EndClass, not even an explicit nil
func (o *Identity) UnsetEndClass() {
	o.EndClass.Unset()
}

// GetCernDepartment returns the CernDepartment field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetCernDepartment() string {
	if o == nil || IsNil(o.CernDepartment.Get()) {
		var ret string
		return ret
	}
	return *o.CernDepartment.Get()
}

// GetCernDepartmentOk returns a tuple with the CernDepartment field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetCernDepartmentOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.CernDepartment.Get(), o.CernDepartment.IsSet()
}

// HasCernDepartment returns a boolean if a field has been set.
func (o *Identity) HasCernDepartment() bool {
	if o != nil && o.CernDepartment.IsSet() {
		return true
	}

	return false
}

// SetCernDepartment gets a reference to the given NullableString and assigns it to the CernDepartment field.
func (o *Identity) SetCernDepartment(v string) {
	o.CernDepartment.Set(&v)
}

// SetCernDepartmentNil sets the value for CernDepartment to be an explicit nil
func (o *Identity) SetCernDepartmentNil() {
	o.CernDepartment.Set(nil)
}

// UnsetCernDepartment ensures that no value is present for CernDepartment, not even an explicit nil
func (o *Identity) UnsetCernDepartment() {
	o.CernDepartment.Unset()
}

// GetCernGroup returns the CernGroup field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetCernGroup() string {
	if o == nil || IsNil(o.CernGroup.Get()) {
		var ret string
		return ret
	}
	return *o.CernGroup.Get()
}

// GetCernGroupOk returns a tuple with the CernGroup field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetCernGroupOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.CernGroup.Get(), o.CernGroup.IsSet()
}

// HasCernGroup returns a boolean if a field has been set.
func (o *Identity) HasCernGroup() bool {
	if o != nil && o.CernGroup.IsSet() {
		return true
	}

	return false
}

// SetCernGroup gets a reference to the given NullableString and assigns it to the CernGroup field.
func (o *Identity) SetCernGroup(v string) {
	o.CernGroup.Set(&v)
}

// SetCernGroupNil sets the value for CernGroup to be an explicit nil
func (o *Identity) SetCernGroupNil() {
	o.CernGroup.Set(nil)
}

// UnsetCernGroup ensures that no value is present for CernGroup, not even an explicit nil
func (o *Identity) UnsetCernGroup() {
	o.CernGroup.Unset()
}

// GetCernSection returns the CernSection field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetCernSection() string {
	if o == nil || IsNil(o.CernSection.Get()) {
		var ret string
		return ret
	}
	return *o.CernSection.Get()
}

// GetCernSectionOk returns a tuple with the CernSection field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetCernSectionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.CernSection.Get(), o.CernSection.IsSet()
}

// HasCernSection returns a boolean if a field has been set.
func (o *Identity) HasCernSection() bool {
	if o != nil && o.CernSection.IsSet() {
		return true
	}

	return false
}

// SetCernSection gets a reference to the given NullableString and assigns it to the CernSection field.
func (o *Identity) SetCernSection(v string) {
	o.CernSection.Set(&v)
}

// SetCernSectionNil sets the value for CernSection to be an explicit nil
func (o *Identity) SetCernSectionNil() {
	o.CernSection.Set(nil)
}

// UnsetCernSection ensures that no value is present for CernSection, not even an explicit nil
func (o *Identity) UnsetCernSection() {
	o.CernSection.Unset()
}

// GetInstituteName returns the InstituteName field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetInstituteName() string {
	if o == nil || IsNil(o.InstituteName.Get()) {
		var ret string
		return ret
	}
	return *o.InstituteName.Get()
}

// GetInstituteNameOk returns a tuple with the InstituteName field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetInstituteNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.InstituteName.Get(), o.InstituteName.IsSet()
}

// HasInstituteName returns a boolean if a field has been set.
func (o *Identity) HasInstituteName() bool {
	if o != nil && o.InstituteName.IsSet() {
		return true
	}

	return false
}

// SetInstituteName gets a reference to the given NullableString and assigns it to the InstituteName field.
func (o *Identity) SetInstituteName(v string) {
	o.InstituteName.Set(&v)
}

// SetInstituteNameNil sets the value for InstituteName to be an explicit nil
func (o *Identity) SetInstituteNameNil() {
	o.InstituteName.Set(nil)
}

// UnsetInstituteName ensures that no value is present for InstituteName, not even an explicit nil
func (o *Identity) UnsetInstituteName() {
	o.InstituteName.Unset()
}

// GetInstituteAbbreviation returns the InstituteAbbreviation field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetInstituteAbbreviation() string {
	if o == nil || IsNil(o.InstituteAbbreviation.Get()) {
		var ret string
		return ret
	}
	return *o.InstituteAbbreviation.Get()
}

// GetInstituteAbbreviationOk returns a tuple with the InstituteAbbreviation field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetInstituteAbbreviationOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.InstituteAbbreviation.Get(), o.InstituteAbbreviation.IsSet()
}

// HasInstituteAbbreviation returns a boolean if a field has been set.
func (o *Identity) HasInstituteAbbreviation() bool {
	if o != nil && o.InstituteAbbreviation.IsSet() {
		return true
	}

	return false
}

// SetInstituteAbbreviation gets a reference to the given NullableString and assigns it to the InstituteAbbreviation field.
func (o *Identity) SetInstituteAbbreviation(v string) {
	o.InstituteAbbreviation.Set(&v)
}

// SetInstituteAbbreviationNil sets the value for InstituteAbbreviation to be an explicit nil
func (o *Identity) SetInstituteAbbreviationNil() {
	o.InstituteAbbreviation.Set(nil)
}

// UnsetInstituteAbbreviation ensures that no value is present for InstituteAbbreviation, not even an explicit nil
func (o *Identity) UnsetInstituteAbbreviation() {
	o.InstituteAbbreviation.Unset()
}

// GetComputingRulesAcceptedFlag returns the ComputingRulesAcceptedFlag field value if set, zero value otherwise.
func (o *Identity) GetComputingRulesAcceptedFlag() bool {
	if o == nil || IsNil(o.ComputingRulesAcceptedFlag) {
		var ret bool
		return ret
	}
	return *o.ComputingRulesAcceptedFlag
}

// GetComputingRulesAcceptedFlagOk returns a tuple with the ComputingRulesAcceptedFlag field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Identity) GetComputingRulesAcceptedFlagOk() (*bool, bool) {
	if o == nil || IsNil(o.ComputingRulesAcceptedFlag) {
		return nil, false
	}
	return o.ComputingRulesAcceptedFlag, true
}

// HasComputingRulesAcceptedFlag returns a boolean if a field has been set.
func (o *Identity) HasComputingRulesAcceptedFlag() bool {
	if o != nil && !IsNil(o.ComputingRulesAcceptedFlag) {
		return true
	}

	return false
}

// SetComputingRulesAcceptedFlag gets a reference to the given bool and assigns it to the ComputingRulesAcceptedFlag field.
func (o *Identity) SetComputingRulesAcceptedFlag(v bool) {
	o.ComputingRulesAcceptedFlag = &v
}

// GetComputingRulesAccepted returns the ComputingRulesAccepted field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetComputingRulesAccepted() time.Time {
	if o == nil || IsNil(o.ComputingRulesAccepted.Get()) {
		var ret time.Time
		return ret
	}
	return *o.ComputingRulesAccepted.Get()
}

// GetComputingRulesAcceptedOk returns a tuple with the ComputingRulesAccepted field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetComputingRulesAcceptedOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.ComputingRulesAccepted.Get(), o.ComputingRulesAccepted.IsSet()
}

// HasComputingRulesAccepted returns a boolean if a field has been set.
func (o *Identity) HasComputingRulesAccepted() bool {
	if o != nil && o.ComputingRulesAccepted.IsSet() {
		return true
	}

	return false
}

// SetComputingRulesAccepted gets a reference to the given NullableTime and assigns it to the ComputingRulesAccepted field.
func (o *Identity) SetComputingRulesAccepted(v time.Time) {
	o.ComputingRulesAccepted.Set(&v)
}

// SetComputingRulesAcceptedNil sets the value for ComputingRulesAccepted to be an explicit nil
func (o *Identity) SetComputingRulesAcceptedNil() {
	o.ComputingRulesAccepted.Set(nil)
}

// UnsetComputingRulesAccepted ensures that no value is present for ComputingRulesAccepted, not even an explicit nil
func (o *Identity) UnsetComputingRulesAccepted() {
	o.ComputingRulesAccepted.Unset()
}

// GetComputingRulesValidUntil returns the ComputingRulesValidUntil field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetComputingRulesValidUntil() time.Time {
	if o == nil || IsNil(o.ComputingRulesValidUntil.Get()) {
		var ret time.Time
		return ret
	}
	return *o.ComputingRulesValidUntil.Get()
}

// GetComputingRulesValidUntilOk returns a tuple with the ComputingRulesValidUntil field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetComputingRulesValidUntilOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.ComputingRulesValidUntil.Get(), o.ComputingRulesValidUntil.IsSet()
}

// HasComputingRulesValidUntil returns a boolean if a field has been set.
func (o *Identity) HasComputingRulesValidUntil() bool {
	if o != nil && o.ComputingRulesValidUntil.IsSet() {
		return true
	}

	return false
}

// SetComputingRulesValidUntil gets a reference to the given NullableTime and assigns it to the ComputingRulesValidUntil field.
func (o *Identity) SetComputingRulesValidUntil(v time.Time) {
	o.ComputingRulesValidUntil.Set(&v)
}

// SetComputingRulesValidUntilNil sets the value for ComputingRulesValidUntil to be an explicit nil
func (o *Identity) SetComputingRulesValidUntilNil() {
	o.ComputingRulesValidUntil.Set(nil)
}

// UnsetComputingRulesValidUntil ensures that no value is present for ComputingRulesValidUntil, not even an explicit nil
func (o *Identity) UnsetComputingRulesValidUntil() {
	o.ComputingRulesValidUntil.Unset()
}

// GetPreferredCernLanguage returns the PreferredCernLanguage field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetPreferredCernLanguage() string {
	if o == nil || IsNil(o.PreferredCernLanguage.Get()) {
		var ret string
		return ret
	}
	return *o.PreferredCernLanguage.Get()
}

// GetPreferredCernLanguageOk returns a tuple with the PreferredCernLanguage field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetPreferredCernLanguageOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.PreferredCernLanguage.Get(), o.PreferredCernLanguage.IsSet()
}

// HasPreferredCernLanguage returns a boolean if a field has been set.
func (o *Identity) HasPreferredCernLanguage() bool {
	if o != nil && o.PreferredCernLanguage.IsSet() {
		return true
	}

	return false
}

// SetPreferredCernLanguage gets a reference to the given NullableString and assigns it to the PreferredCernLanguage field.
func (o *Identity) SetPreferredCernLanguage(v string) {
	o.PreferredCernLanguage.Set(&v)
}

// SetPreferredCernLanguageNil sets the value for PreferredCernLanguage to be an explicit nil
func (o *Identity) SetPreferredCernLanguageNil() {
	o.PreferredCernLanguage.Set(nil)
}

// UnsetPreferredCernLanguage ensures that no value is present for PreferredCernLanguage, not even an explicit nil
func (o *Identity) UnsetPreferredCernLanguage() {
	o.PreferredCernLanguage.Unset()
}

// GetTelephone1 returns the Telephone1 field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetTelephone1() string {
	if o == nil || IsNil(o.Telephone1.Get()) {
		var ret string
		return ret
	}
	return *o.Telephone1.Get()
}

// GetTelephone1Ok returns a tuple with the Telephone1 field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetTelephone1Ok() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Telephone1.Get(), o.Telephone1.IsSet()
}

// HasTelephone1 returns a boolean if a field has been set.
func (o *Identity) HasTelephone1() bool {
	if o != nil && o.Telephone1.IsSet() {
		return true
	}

	return false
}

// SetTelephone1 gets a reference to the given NullableString and assigns it to the Telephone1 field.
func (o *Identity) SetTelephone1(v string) {
	o.Telephone1.Set(&v)
}

// SetTelephone1Nil sets the value for Telephone1 to be an explicit nil
func (o *Identity) SetTelephone1Nil() {
	o.Telephone1.Set(nil)
}

// UnsetTelephone1 ensures that no value is present for Telephone1, not even an explicit nil
func (o *Identity) UnsetTelephone1() {
	o.Telephone1.Unset()
}

// GetTelephone2 returns the Telephone2 field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetTelephone2() string {
	if o == nil || IsNil(o.Telephone2.Get()) {
		var ret string
		return ret
	}
	return *o.Telephone2.Get()
}

// GetTelephone2Ok returns a tuple with the Telephone2 field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetTelephone2Ok() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Telephone2.Get(), o.Telephone2.IsSet()
}

// HasTelephone2 returns a boolean if a field has been set.
func (o *Identity) HasTelephone2() bool {
	if o != nil && o.Telephone2.IsSet() {
		return true
	}

	return false
}

// SetTelephone2 gets a reference to the given NullableString and assigns it to the Telephone2 field.
func (o *Identity) SetTelephone2(v string) {
	o.Telephone2.Set(&v)
}

// SetTelephone2Nil sets the value for Telephone2 to be an explicit nil
func (o *Identity) SetTelephone2Nil() {
	o.Telephone2.Set(nil)
}

// UnsetTelephone2 ensures that no value is present for Telephone2, not even an explicit nil
func (o *Identity) UnsetTelephone2() {
	o.Telephone2.Unset()
}

// GetPortablePhone returns the PortablePhone field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetPortablePhone() string {
	if o == nil || IsNil(o.PortablePhone.Get()) {
		var ret string
		return ret
	}
	return *o.PortablePhone.Get()
}

// GetPortablePhoneOk returns a tuple with the PortablePhone field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetPortablePhoneOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.PortablePhone.Get(), o.PortablePhone.IsSet()
}

// HasPortablePhone returns a boolean if a field has been set.
func (o *Identity) HasPortablePhone() bool {
	if o != nil && o.PortablePhone.IsSet() {
		return true
	}

	return false
}

// SetPortablePhone gets a reference to the given NullableString and assigns it to the PortablePhone field.
func (o *Identity) SetPortablePhone(v string) {
	o.PortablePhone.Set(&v)
}

// SetPortablePhoneNil sets the value for PortablePhone to be an explicit nil
func (o *Identity) SetPortablePhoneNil() {
	o.PortablePhone.Set(nil)
}

// UnsetPortablePhone ensures that no value is present for PortablePhone, not even an explicit nil
func (o *Identity) UnsetPortablePhone() {
	o.PortablePhone.Unset()
}

// GetEdhAuthPwdExpiry returns the EdhAuthPwdExpiry field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetEdhAuthPwdExpiry() time.Time {
	if o == nil || IsNil(o.EdhAuthPwdExpiry.Get()) {
		var ret time.Time
		return ret
	}
	return *o.EdhAuthPwdExpiry.Get()
}

// GetEdhAuthPwdExpiryOk returns a tuple with the EdhAuthPwdExpiry field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetEdhAuthPwdExpiryOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.EdhAuthPwdExpiry.Get(), o.EdhAuthPwdExpiry.IsSet()
}

// HasEdhAuthPwdExpiry returns a boolean if a field has been set.
func (o *Identity) HasEdhAuthPwdExpiry() bool {
	if o != nil && o.EdhAuthPwdExpiry.IsSet() {
		return true
	}

	return false
}

// SetEdhAuthPwdExpiry gets a reference to the given NullableTime and assigns it to the EdhAuthPwdExpiry field.
func (o *Identity) SetEdhAuthPwdExpiry(v time.Time) {
	o.EdhAuthPwdExpiry.Set(&v)
}

// SetEdhAuthPwdExpiryNil sets the value for EdhAuthPwdExpiry to be an explicit nil
func (o *Identity) SetEdhAuthPwdExpiryNil() {
	o.EdhAuthPwdExpiry.Set(nil)
}

// UnsetEdhAuthPwdExpiry ensures that no value is present for EdhAuthPwdExpiry, not even an explicit nil
func (o *Identity) UnsetEdhAuthPwdExpiry() {
	o.EdhAuthPwdExpiry.Unset()
}

// GetEduPersonUniqueID returns the EduPersonUniqueID field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetEduPersonUniqueID() string {
	if o == nil || IsNil(o.EduPersonUniqueID.Get()) {
		var ret string
		return ret
	}
	return *o.EduPersonUniqueID.Get()
}

// GetEduPersonUniqueIDOk returns a tuple with the EduPersonUniqueID field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetEduPersonUniqueIDOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.EduPersonUniqueID.Get(), o.EduPersonUniqueID.IsSet()
}

// HasEduPersonUniqueID returns a boolean if a field has been set.
func (o *Identity) HasEduPersonUniqueID() bool {
	if o != nil && o.EduPersonUniqueID.IsSet() {
		return true
	}

	return false
}

// SetEduPersonUniqueID gets a reference to the given NullableString and assigns it to the EduPersonUniqueID field.
func (o *Identity) SetEduPersonUniqueID(v string) {
	o.EduPersonUniqueID.Set(&v)
}

// SetEduPersonUniqueIDNil sets the value for EduPersonUniqueID to be an explicit nil
func (o *Identity) SetEduPersonUniqueIDNil() {
	o.EduPersonUniqueID.Set(nil)
}

// UnsetEduPersonUniqueID ensures that no value is present for EduPersonUniqueID, not even an explicit nil
func (o *Identity) UnsetEduPersonUniqueID() {
	o.EduPersonUniqueID.Unset()
}

// GetOrcid returns the Orcid field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetOrcid() string {
	if o == nil || IsNil(o.Orcid.Get()) {
		var ret string
		return ret
	}
	return *o.Orcid.Get()
}

// GetOrcidOk returns a tuple with the Orcid field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetOrcidOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Orcid.Get(), o.Orcid.IsSet()
}

// HasOrcid returns a boolean if a field has been set.
func (o *Identity) HasOrcid() bool {
	if o != nil && o.Orcid.IsSet() {
		return true
	}

	return false
}

// SetOrcid gets a reference to the given NullableString and assigns it to the Orcid field.
func (o *Identity) SetOrcid(v string) {
	o.Orcid.Set(&v)
}

// SetOrcidNil sets the value for Orcid to be an explicit nil
func (o *Identity) SetOrcidNil() {
	o.Orcid.Set(nil)
}

// UnsetOrcid ensures that no value is present for Orcid, not even an explicit nil
func (o *Identity) UnsetOrcid() {
	o.Orcid.Unset()
}

// GetDescription returns the Description field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetDescription() string {
	if o == nil || IsNil(o.Description.Get()) {
		var ret string
		return ret
	}
	return *o.Description.Get()
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetDescriptionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Description.Get(), o.Description.IsSet()
}

// HasDescription returns a boolean if a field has been set.
func (o *Identity) HasDescription() bool {
	if o != nil && o.Description.IsSet() {
		return true
	}

	return false
}

// SetDescription gets a reference to the given NullableString and assigns it to the Description field.
func (o *Identity) SetDescription(v string) {
	o.Description.Set(&v)
}

// SetDescriptionNil sets the value for Description to be an explicit nil
func (o *Identity) SetDescriptionNil() {
	o.Description.Set(nil)
}

// UnsetDescription ensures that no value is present for Description, not even an explicit nil
func (o *Identity) UnsetDescription() {
	o.Description.Unset()
}

// GetHrEmail returns the HrEmail field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetHrEmail() string {
	if o == nil || IsNil(o.HrEmail.Get()) {
		var ret string
		return ret
	}
	return *o.HrEmail.Get()
}

// GetHrEmailOk returns a tuple with the HrEmail field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetHrEmailOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.HrEmail.Get(), o.HrEmail.IsSet()
}

// HasHrEmail returns a boolean if a field has been set.
func (o *Identity) HasHrEmail() bool {
	if o != nil && o.HrEmail.IsSet() {
		return true
	}

	return false
}

// SetHrEmail gets a reference to the given NullableString and assigns it to the HrEmail field.
func (o *Identity) SetHrEmail(v string) {
	o.HrEmail.Set(&v)
}

// SetHrEmailNil sets the value for HrEmail to be an explicit nil
func (o *Identity) SetHrEmailNil() {
	o.HrEmail.Set(nil)
}

// UnsetHrEmail ensures that no value is present for HrEmail, not even an explicit nil
func (o *Identity) UnsetHrEmail() {
	o.HrEmail.Unset()
}

// GetAtCern returns the AtCern field value if set, zero value otherwise.
func (o *Identity) GetAtCern() bool {
	if o == nil || IsNil(o.AtCern) {
		var ret bool
		return ret
	}
	return *o.AtCern
}

// GetAtCernOk returns a tuple with the AtCern field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Identity) GetAtCernOk() (*bool, bool) {
	if o == nil || IsNil(o.AtCern) {
		return nil, false
	}
	return o.AtCern, true
}

// HasAtCern returns a boolean if a field has been set.
func (o *Identity) HasAtCern() bool {
	if o != nil && !IsNil(o.AtCern) {
		return true
	}

	return false
}

// SetAtCern gets a reference to the given bool and assigns it to the AtCern field.
func (o *Identity) SetAtCern(v bool) {
	o.AtCern = &v
}

// GetPostOfficeBox returns the PostOfficeBox field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetPostOfficeBox() string {
	if o == nil || IsNil(o.PostOfficeBox.Get()) {
		var ret string
		return ret
	}
	return *o.PostOfficeBox.Get()
}

// GetPostOfficeBoxOk returns a tuple with the PostOfficeBox field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetPostOfficeBoxOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.PostOfficeBox.Get(), o.PostOfficeBox.IsSet()
}

// HasPostOfficeBox returns a boolean if a field has been set.
func (o *Identity) HasPostOfficeBox() bool {
	if o != nil && o.PostOfficeBox.IsSet() {
		return true
	}

	return false
}

// SetPostOfficeBox gets a reference to the given NullableString and assigns it to the PostOfficeBox field.
func (o *Identity) SetPostOfficeBox(v string) {
	o.PostOfficeBox.Set(&v)
}

// SetPostOfficeBoxNil sets the value for PostOfficeBox to be an explicit nil
func (o *Identity) SetPostOfficeBoxNil() {
	o.PostOfficeBox.Set(nil)
}

// UnsetPostOfficeBox ensures that no value is present for PostOfficeBox, not even an explicit nil
func (o *Identity) UnsetPostOfficeBox() {
	o.PostOfficeBox.Unset()
}

// GetSupervisor returns the Supervisor field value if set, zero value otherwise.
func (o *Identity) GetSupervisor() Identity {
	if o == nil || IsNil(o.Supervisor) {
		var ret Identity
		return ret
	}
	return *o.Supervisor
}

// GetSupervisorOk returns a tuple with the Supervisor field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Identity) GetSupervisorOk() (*Identity, bool) {
	if o == nil || IsNil(o.Supervisor) {
		return nil, false
	}
	return o.Supervisor, true
}

// HasSupervisor returns a boolean if a field has been set.
func (o *Identity) HasSupervisor() bool {
	if o != nil && !IsNil(o.Supervisor) {
		return true
	}

	return false
}

// SetSupervisor gets a reference to the given Identity and assigns it to the Supervisor field.
func (o *Identity) SetSupervisor(v Identity) {
	o.Supervisor = &v
}

// GetExternalEmail returns the ExternalEmail field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetExternalEmail() string {
	if o == nil || IsNil(o.ExternalEmail.Get()) {
		var ret string
		return ret
	}
	return *o.ExternalEmail.Get()
}

// GetExternalEmailOk returns a tuple with the ExternalEmail field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetExternalEmailOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ExternalEmail.Get(), o.ExternalEmail.IsSet()
}

// HasExternalEmail returns a boolean if a field has been set.
func (o *Identity) HasExternalEmail() bool {
	if o != nil && o.ExternalEmail.IsSet() {
		return true
	}

	return false
}

// SetExternalEmail gets a reference to the given NullableString and assigns it to the ExternalEmail field.
func (o *Identity) SetExternalEmail(v string) {
	o.ExternalEmail.Set(&v)
}

// SetExternalEmailNil sets the value for ExternalEmail to be an explicit nil
func (o *Identity) SetExternalEmailNil() {
	o.ExternalEmail.Set(nil)
}

// UnsetExternalEmail ensures that no value is present for ExternalEmail, not even an explicit nil
func (o *Identity) UnsetExternalEmail() {
	o.ExternalEmail.Unset()
}

// GetPrimaryAccountEmail returns the PrimaryAccountEmail field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetPrimaryAccountEmail() string {
	if o == nil || IsNil(o.PrimaryAccountEmail.Get()) {
		var ret string
		return ret
	}
	return *o.PrimaryAccountEmail.Get()
}

// GetPrimaryAccountEmailOk returns a tuple with the PrimaryAccountEmail field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetPrimaryAccountEmailOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.PrimaryAccountEmail.Get(), o.PrimaryAccountEmail.IsSet()
}

// HasPrimaryAccountEmail returns a boolean if a field has been set.
func (o *Identity) HasPrimaryAccountEmail() bool {
	if o != nil && o.PrimaryAccountEmail.IsSet() {
		return true
	}

	return false
}

// SetPrimaryAccountEmail gets a reference to the given NullableString and assigns it to the PrimaryAccountEmail field.
func (o *Identity) SetPrimaryAccountEmail(v string) {
	o.PrimaryAccountEmail.Set(&v)
}

// SetPrimaryAccountEmailNil sets the value for PrimaryAccountEmail to be an explicit nil
func (o *Identity) SetPrimaryAccountEmailNil() {
	o.PrimaryAccountEmail.Set(nil)
}

// UnsetPrimaryAccountEmail ensures that no value is present for PrimaryAccountEmail, not even an explicit nil
func (o *Identity) UnsetPrimaryAccountEmail() {
	o.PrimaryAccountEmail.Unset()
}

// GetResourceCategory returns the ResourceCategory field value if set, zero value otherwise.
func (o *Identity) GetResourceCategory() ResourceCategory {
	if o == nil || IsNil(o.ResourceCategory) {
		var ret ResourceCategory
		return ret
	}
	return *o.ResourceCategory
}

// GetResourceCategoryOk returns a tuple with the ResourceCategory field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Identity) GetResourceCategoryOk() (*ResourceCategory, bool) {
	if o == nil || IsNil(o.ResourceCategory) {
		return nil, false
	}
	return o.ResourceCategory, true
}

// HasResourceCategory returns a boolean if a field has been set.
func (o *Identity) HasResourceCategory() bool {
	if o != nil && !IsNil(o.ResourceCategory) {
		return true
	}

	return false
}

// SetResourceCategory gets a reference to the given ResourceCategory and assigns it to the ResourceCategory field.
func (o *Identity) SetResourceCategory(v ResourceCategory) {
	o.ResourceCategory = &v
}

// GetReassignable returns the Reassignable field value if set, zero value otherwise.
func (o *Identity) GetReassignable() bool {
	if o == nil || IsNil(o.Reassignable) {
		var ret bool
		return ret
	}
	return *o.Reassignable
}

// GetReassignableOk returns a tuple with the Reassignable field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Identity) GetReassignableOk() (*bool, bool) {
	if o == nil || IsNil(o.Reassignable) {
		return nil, false
	}
	return o.Reassignable, true
}

// HasReassignable returns a boolean if a field has been set.
func (o *Identity) HasReassignable() bool {
	if o != nil && !IsNil(o.Reassignable) {
		return true
	}

	return false
}

// SetReassignable gets a reference to the given bool and assigns it to the Reassignable field.
func (o *Identity) SetReassignable(v bool) {
	o.Reassignable = &v
}

// GetAutoReassign returns the AutoReassign field value if set, zero value otherwise.
func (o *Identity) GetAutoReassign() bool {
	if o == nil || IsNil(o.AutoReassign) {
		var ret bool
		return ret
	}
	return *o.AutoReassign
}

// GetAutoReassignOk returns a tuple with the AutoReassign field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Identity) GetAutoReassignOk() (*bool, bool) {
	if o == nil || IsNil(o.AutoReassign) {
		return nil, false
	}
	return o.AutoReassign, true
}

// HasAutoReassign returns a boolean if a field has been set.
func (o *Identity) HasAutoReassign() bool {
	if o != nil && !IsNil(o.AutoReassign) {
		return true
	}

	return false
}

// SetAutoReassign gets a reference to the given bool and assigns it to the AutoReassign field.
func (o *Identity) SetAutoReassign(v bool) {
	o.AutoReassign = &v
}

// GetPendingAction returns the PendingAction field value if set, zero value otherwise.
// Deprecated
func (o *Identity) GetPendingAction() bool {
	if o == nil || IsNil(o.PendingAction) {
		var ret bool
		return ret
	}
	return *o.PendingAction
}

// GetPendingActionOk returns a tuple with the PendingAction field value if set, nil otherwise
// and a boolean to check if the value has been set.
// Deprecated
func (o *Identity) GetPendingActionOk() (*bool, bool) {
	if o == nil || IsNil(o.PendingAction) {
		return nil, false
	}
	return o.PendingAction, true
}

// HasPendingAction returns a boolean if a field has been set.
func (o *Identity) HasPendingAction() bool {
	if o != nil && !IsNil(o.PendingAction) {
		return true
	}

	return false
}

// SetPendingAction gets a reference to the given bool and assigns it to the PendingAction field.
// Deprecated
func (o *Identity) SetPendingAction(v bool) {
	o.PendingAction = &v
}

// GetDisabled returns the Disabled field value if set, zero value otherwise.
func (o *Identity) GetDisabled() bool {
	if o == nil || IsNil(o.Disabled) {
		var ret bool
		return ret
	}
	return *o.Disabled
}

// GetDisabledOk returns a tuple with the Disabled field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Identity) GetDisabledOk() (*bool, bool) {
	if o == nil || IsNil(o.Disabled) {
		return nil, false
	}
	return o.Disabled, true
}

// HasDisabled returns a boolean if a field has been set.
func (o *Identity) HasDisabled() bool {
	if o != nil && !IsNil(o.Disabled) {
		return true
	}

	return false
}

// SetDisabled gets a reference to the given bool and assigns it to the Disabled field.
func (o *Identity) SetDisabled(v bool) {
	o.Disabled = &v
}

// GetBlocked returns the Blocked field value if set, zero value otherwise.
func (o *Identity) GetBlocked() bool {
	if o == nil || IsNil(o.Blocked) {
		var ret bool
		return ret
	}
	return *o.Blocked
}

// GetBlockedOk returns a tuple with the Blocked field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Identity) GetBlockedOk() (*bool, bool) {
	if o == nil || IsNil(o.Blocked) {
		return nil, false
	}
	return o.Blocked, true
}

// HasBlocked returns a boolean if a field has been set.
func (o *Identity) HasBlocked() bool {
	if o != nil && !IsNil(o.Blocked) {
		return true
	}

	return false
}

// SetBlocked gets a reference to the given bool and assigns it to the Blocked field.
func (o *Identity) SetBlocked(v bool) {
	o.Blocked = &v
}

// GetSecurityIssues returns the SecurityIssues field value if set, zero value otherwise.
func (o *Identity) GetSecurityIssues() bool {
	if o == nil || IsNil(o.SecurityIssues) {
		var ret bool
		return ret
	}
	return *o.SecurityIssues
}

// GetSecurityIssuesOk returns a tuple with the SecurityIssues field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Identity) GetSecurityIssuesOk() (*bool, bool) {
	if o == nil || IsNil(o.SecurityIssues) {
		return nil, false
	}
	return o.SecurityIssues, true
}

// HasSecurityIssues returns a boolean if a field has been set.
func (o *Identity) HasSecurityIssues() bool {
	if o != nil && !IsNil(o.SecurityIssues) {
		return true
	}

	return false
}

// SetSecurityIssues gets a reference to the given bool and assigns it to the SecurityIssues field.
func (o *Identity) SetSecurityIssues(v bool) {
	o.SecurityIssues = &v
}

// GetBlockingReason returns the BlockingReason field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetBlockingReason() string {
	if o == nil || IsNil(o.BlockingReason.Get()) {
		var ret string
		return ret
	}
	return *o.BlockingReason.Get()
}

// GetBlockingReasonOk returns a tuple with the BlockingReason field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetBlockingReasonOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.BlockingReason.Get(), o.BlockingReason.IsSet()
}

// HasBlockingReason returns a boolean if a field has been set.
func (o *Identity) HasBlockingReason() bool {
	if o != nil && o.BlockingReason.IsSet() {
		return true
	}

	return false
}

// SetBlockingReason gets a reference to the given NullableString and assigns it to the BlockingReason field.
func (o *Identity) SetBlockingReason(v string) {
	o.BlockingReason.Set(&v)
}

// SetBlockingReasonNil sets the value for BlockingReason to be an explicit nil
func (o *Identity) SetBlockingReasonNil() {
	o.BlockingReason.Set(nil)
}

// UnsetBlockingReason ensures that no value is present for BlockingReason, not even an explicit nil
func (o *Identity) UnsetBlockingReason() {
	o.BlockingReason.Unset()
}

// GetBlockingTime returns the BlockingTime field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetBlockingTime() time.Time {
	if o == nil || IsNil(o.BlockingTime.Get()) {
		var ret time.Time
		return ret
	}
	return *o.BlockingTime.Get()
}

// GetBlockingTimeOk returns a tuple with the BlockingTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetBlockingTimeOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.BlockingTime.Get(), o.BlockingTime.IsSet()
}

// HasBlockingTime returns a boolean if a field has been set.
func (o *Identity) HasBlockingTime() bool {
	if o != nil && o.BlockingTime.IsSet() {
		return true
	}

	return false
}

// SetBlockingTime gets a reference to the given NullableTime and assigns it to the BlockingTime field.
func (o *Identity) SetBlockingTime(v time.Time) {
	o.BlockingTime.Set(&v)
}

// SetBlockingTimeNil sets the value for BlockingTime to be an explicit nil
func (o *Identity) SetBlockingTimeNil() {
	o.BlockingTime.Set(nil)
}

// UnsetBlockingTime ensures that no value is present for BlockingTime, not even an explicit nil
func (o *Identity) UnsetBlockingTime() {
	o.BlockingTime.Unset()
}

// GetBlockingDeadline returns the BlockingDeadline field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetBlockingDeadline() time.Time {
	if o == nil || IsNil(o.BlockingDeadline.Get()) {
		var ret time.Time
		return ret
	}
	return *o.BlockingDeadline.Get()
}

// GetBlockingDeadlineOk returns a tuple with the BlockingDeadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetBlockingDeadlineOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.BlockingDeadline.Get(), o.BlockingDeadline.IsSet()
}

// HasBlockingDeadline returns a boolean if a field has been set.
func (o *Identity) HasBlockingDeadline() bool {
	if o != nil && o.BlockingDeadline.IsSet() {
		return true
	}

	return false
}

// SetBlockingDeadline gets a reference to the given NullableTime and assigns it to the BlockingDeadline field.
func (o *Identity) SetBlockingDeadline(v time.Time) {
	o.BlockingDeadline.Set(&v)
}

// SetBlockingDeadlineNil sets the value for BlockingDeadline to be an explicit nil
func (o *Identity) SetBlockingDeadlineNil() {
	o.BlockingDeadline.Set(nil)
}

// UnsetBlockingDeadline ensures that no value is present for BlockingDeadline, not even an explicit nil
func (o *Identity) UnsetBlockingDeadline() {
	o.BlockingDeadline.Unset()
}

// GetArchiveDeadline returns the ArchiveDeadline field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetArchiveDeadline() time.Time {
	if o == nil || IsNil(o.ArchiveDeadline.Get()) {
		var ret time.Time
		return ret
	}
	return *o.ArchiveDeadline.Get()
}

// GetArchiveDeadlineOk returns a tuple with the ArchiveDeadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetArchiveDeadlineOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.ArchiveDeadline.Get(), o.ArchiveDeadline.IsSet()
}

// HasArchiveDeadline returns a boolean if a field has been set.
func (o *Identity) HasArchiveDeadline() bool {
	if o != nil && o.ArchiveDeadline.IsSet() {
		return true
	}

	return false
}

// SetArchiveDeadline gets a reference to the given NullableTime and assigns it to the ArchiveDeadline field.
func (o *Identity) SetArchiveDeadline(v time.Time) {
	o.ArchiveDeadline.Set(&v)
}

// SetArchiveDeadlineNil sets the value for ArchiveDeadline to be an explicit nil
func (o *Identity) SetArchiveDeadlineNil() {
	o.ArchiveDeadline.Set(nil)
}

// UnsetArchiveDeadline ensures that no value is present for ArchiveDeadline, not even an explicit nil
func (o *Identity) UnsetArchiveDeadline() {
	o.ArchiveDeadline.Unset()
}

// GetDeleteDeadline returns the DeleteDeadline field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetDeleteDeadline() time.Time {
	if o == nil || IsNil(o.DeleteDeadline.Get()) {
		var ret time.Time
		return ret
	}
	return *o.DeleteDeadline.Get()
}

// GetDeleteDeadlineOk returns a tuple with the DeleteDeadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetDeleteDeadlineOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.DeleteDeadline.Get(), o.DeleteDeadline.IsSet()
}

// HasDeleteDeadline returns a boolean if a field has been set.
func (o *Identity) HasDeleteDeadline() bool {
	if o != nil && o.DeleteDeadline.IsSet() {
		return true
	}

	return false
}

// SetDeleteDeadline gets a reference to the given NullableTime and assigns it to the DeleteDeadline field.
func (o *Identity) SetDeleteDeadline(v time.Time) {
	o.DeleteDeadline.Set(&v)
}

// SetDeleteDeadlineNil sets the value for DeleteDeadline to be an explicit nil
func (o *Identity) SetDeleteDeadlineNil() {
	o.DeleteDeadline.Set(nil)
}

// UnsetDeleteDeadline ensures that no value is present for DeleteDeadline, not even an explicit nil
func (o *Identity) UnsetDeleteDeadline() {
	o.DeleteDeadline.Unset()
}

// GetExpirationDeadline returns the ExpirationDeadline field value if set, zero value otherwise (both if not set or set to explicit null).
// Deprecated
func (o *Identity) GetExpirationDeadline() time.Time {
	if o == nil || IsNil(o.ExpirationDeadline.Get()) {
		var ret time.Time
		return ret
	}
	return *o.ExpirationDeadline.Get()
}

// GetExpirationDeadlineOk returns a tuple with the ExpirationDeadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
// Deprecated
func (o *Identity) GetExpirationDeadlineOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.ExpirationDeadline.Get(), o.ExpirationDeadline.IsSet()
}

// HasExpirationDeadline returns a boolean if a field has been set.
func (o *Identity) HasExpirationDeadline() bool {
	if o != nil && o.ExpirationDeadline.IsSet() {
		return true
	}

	return false
}

// SetExpirationDeadline gets a reference to the given NullableTime and assigns it to the ExpirationDeadline field.
// Deprecated
func (o *Identity) SetExpirationDeadline(v time.Time) {
	o.ExpirationDeadline.Set(&v)
}

// SetExpirationDeadlineNil sets the value for ExpirationDeadline to be an explicit nil
func (o *Identity) SetExpirationDeadlineNil() {
	o.ExpirationDeadline.Set(nil)
}

// UnsetExpirationDeadline ensures that no value is present for ExpirationDeadline, not even an explicit nil
func (o *Identity) UnsetExpirationDeadline() {
	o.ExpirationDeadline.Unset()
}

// GetOwnerId returns the OwnerId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetOwnerId() string {
	if o == nil || IsNil(o.OwnerId.Get()) {
		var ret string
		return ret
	}
	return *o.OwnerId.Get()
}

// GetOwnerIdOk returns a tuple with the OwnerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetOwnerIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.OwnerId.Get(), o.OwnerId.IsSet()
}

// HasOwnerId returns a boolean if a field has been set.
func (o *Identity) HasOwnerId() bool {
	if o != nil && o.OwnerId.IsSet() {
		return true
	}

	return false
}

// SetOwnerId gets a reference to the given NullableString and assigns it to the OwnerId field.
func (o *Identity) SetOwnerId(v string) {
	o.OwnerId.Set(&v)
}

// SetOwnerIdNil sets the value for OwnerId to be an explicit nil
func (o *Identity) SetOwnerIdNil() {
	o.OwnerId.Set(nil)
}

// UnsetOwnerId ensures that no value is present for OwnerId, not even an explicit nil
func (o *Identity) UnsetOwnerId() {
	o.OwnerId.Unset()
}

// GetInternalState returns the InternalState field value if set, zero value otherwise.
func (o *Identity) GetInternalState() ResourceState {
	if o == nil || IsNil(o.InternalState) {
		var ret ResourceState
		return ret
	}
	return *o.InternalState
}

// GetInternalStateOk returns a tuple with the InternalState field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Identity) GetInternalStateOk() (*ResourceState, bool) {
	if o == nil || IsNil(o.InternalState) {
		return nil, false
	}
	return o.InternalState, true
}

// HasInternalState returns a boolean if a field has been set.
func (o *Identity) HasInternalState() bool {
	if o != nil && !IsNil(o.InternalState) {
		return true
	}

	return false
}

// SetInternalState gets a reference to the given ResourceState and assigns it to the InternalState field.
func (o *Identity) SetInternalState(v ResourceState) {
	o.InternalState = &v
}

// GetState returns the State field value if set, zero value otherwise.
func (o *Identity) GetState() ResourceState {
	if o == nil || IsNil(o.State) {
		var ret ResourceState
		return ret
	}
	return *o.State
}

// GetStateOk returns a tuple with the State field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Identity) GetStateOk() (*ResourceState, bool) {
	if o == nil || IsNil(o.State) {
		return nil, false
	}
	return o.State, true
}

// HasState returns a boolean if a field has been set.
func (o *Identity) HasState() bool {
	if o != nil && !IsNil(o.State) {
		return true
	}

	return false
}

// SetState gets a reference to the given ResourceState and assigns it to the State field.
func (o *Identity) SetState(v ResourceState) {
	o.State = &v
}

// GetLastStateChangeTime returns the LastStateChangeTime field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetLastStateChangeTime() time.Time {
	if o == nil || IsNil(o.LastStateChangeTime.Get()) {
		var ret time.Time
		return ret
	}
	return *o.LastStateChangeTime.Get()
}

// GetLastStateChangeTimeOk returns a tuple with the LastStateChangeTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetLastStateChangeTimeOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.LastStateChangeTime.Get(), o.LastStateChangeTime.IsSet()
}

// HasLastStateChangeTime returns a boolean if a field has been set.
func (o *Identity) HasLastStateChangeTime() bool {
	if o != nil && o.LastStateChangeTime.IsSet() {
		return true
	}

	return false
}

// SetLastStateChangeTime gets a reference to the given NullableTime and assigns it to the LastStateChangeTime field.
func (o *Identity) SetLastStateChangeTime(v time.Time) {
	o.LastStateChangeTime.Set(&v)
}

// SetLastStateChangeTimeNil sets the value for LastStateChangeTime to be an explicit nil
func (o *Identity) SetLastStateChangeTimeNil() {
	o.LastStateChangeTime.Set(nil)
}

// UnsetLastStateChangeTime ensures that no value is present for LastStateChangeTime, not even an explicit nil
func (o *Identity) UnsetLastStateChangeTime() {
	o.LastStateChangeTime.Unset()
}

// GetValidityLimit returns the ValidityLimit field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetValidityLimit() time.Time {
	if o == nil || IsNil(o.ValidityLimit.Get()) {
		var ret time.Time
		return ret
	}
	return *o.ValidityLimit.Get()
}

// GetValidityLimitOk returns a tuple with the ValidityLimit field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetValidityLimitOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.ValidityLimit.Get(), o.ValidityLimit.IsSet()
}

// HasValidityLimit returns a boolean if a field has been set.
func (o *Identity) HasValidityLimit() bool {
	if o != nil && o.ValidityLimit.IsSet() {
		return true
	}

	return false
}

// SetValidityLimit gets a reference to the given NullableTime and assigns it to the ValidityLimit field.
func (o *Identity) SetValidityLimit(v time.Time) {
	o.ValidityLimit.Set(&v)
}

// SetValidityLimitNil sets the value for ValidityLimit to be an explicit nil
func (o *Identity) SetValidityLimitNil() {
	o.ValidityLimit.Set(nil)
}

// UnsetValidityLimit ensures that no value is present for ValidityLimit, not even an explicit nil
func (o *Identity) UnsetValidityLimit() {
	o.ValidityLimit.Unset()
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Identity) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Identity) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *Identity) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *Identity) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *Identity) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *Identity) UnsetId() {
	o.Id.Unset()
}

// GetCreationTime returns the CreationTime field value if set, zero value otherwise.
func (o *Identity) GetCreationTime() time.Time {
	if o == nil || IsNil(o.CreationTime) {
		var ret time.Time
		return ret
	}
	return *o.CreationTime
}

// GetCreationTimeOk returns a tuple with the CreationTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Identity) GetCreationTimeOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreationTime) {
		return nil, false
	}
	return o.CreationTime, true
}

// HasCreationTime returns a boolean if a field has been set.
func (o *Identity) HasCreationTime() bool {
	if o != nil && !IsNil(o.CreationTime) {
		return true
	}

	return false
}

// SetCreationTime gets a reference to the given time.Time and assigns it to the CreationTime field.
func (o *Identity) SetCreationTime(v time.Time) {
	o.CreationTime = &v
}

func (o Identity) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Identity) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["type"] = o.Type
	if o.Upn.IsSet() {
		toSerialize["upn"] = o.Upn.Get()
	}
	toSerialize["displayName"] = o.DisplayName
	if o.FirstName.IsSet() {
		toSerialize["firstName"] = o.FirstName.Get()
	}
	if o.LastName.IsSet() {
		toSerialize["lastName"] = o.LastName.Get()
	}
	if o.BirthDate.IsSet() {
		toSerialize["birthDate"] = o.BirthDate.Get()
	}
	if o.PersonId.IsSet() {
		toSerialize["personId"] = o.PersonId.Get()
	}
	if o.CernPersonId.IsSet() {
		toSerialize["cernPersonId"] = o.CernPersonId.Get()
	}
	if o.SupervisorId.IsSet() {
		toSerialize["supervisorId"] = o.SupervisorId.Get()
	}
	if o.DirectResponsibleId.IsSet() {
		toSerialize["directResponsibleId"] = o.DirectResponsibleId.Get()
	}
	if o.Source.IsSet() {
		toSerialize["source"] = o.Source.Get()
	}
	toSerialize["unconfirmed"] = o.Unconfirmed
	if o.UnconfirmedEmail.IsSet() {
		toSerialize["unconfirmedEmail"] = o.UnconfirmedEmail.Get()
	}
	if o.PrimaryAccountId.IsSet() {
		toSerialize["primaryAccountId"] = o.PrimaryAccountId.Get()
	}
	if o.Uid.IsSet() {
		toSerialize["uid"] = o.Uid.Get()
	}
	if o.Gid.IsSet() {
		toSerialize["gid"] = o.Gid.Get()
	}
	if o.Building.IsSet() {
		toSerialize["building"] = o.Building.Get()
	}
	if o.Floor.IsSet() {
		toSerialize["floor"] = o.Floor.Get()
	}
	if o.Room.IsSet() {
		toSerialize["room"] = o.Room.Get()
	}
	if !IsNil(o.ActiveUser) {
		toSerialize["activeUser"] = o.ActiveUser
	}
	if o.CernClass.IsSet() {
		toSerialize["cernClass"] = o.CernClass.Get()
	}
	if o.StartClass.IsSet() {
		toSerialize["startClass"] = o.StartClass.Get()
	}
	if o.EndClass.IsSet() {
		toSerialize["endClass"] = o.EndClass.Get()
	}
	if o.CernDepartment.IsSet() {
		toSerialize["cernDepartment"] = o.CernDepartment.Get()
	}
	if o.CernGroup.IsSet() {
		toSerialize["cernGroup"] = o.CernGroup.Get()
	}
	if o.CernSection.IsSet() {
		toSerialize["cernSection"] = o.CernSection.Get()
	}
	if o.InstituteName.IsSet() {
		toSerialize["instituteName"] = o.InstituteName.Get()
	}
	if o.InstituteAbbreviation.IsSet() {
		toSerialize["instituteAbbreviation"] = o.InstituteAbbreviation.Get()
	}
	if !IsNil(o.ComputingRulesAcceptedFlag) {
		toSerialize["computingRulesAcceptedFlag"] = o.ComputingRulesAcceptedFlag
	}
	if o.ComputingRulesAccepted.IsSet() {
		toSerialize["computingRulesAccepted"] = o.ComputingRulesAccepted.Get()
	}
	if o.ComputingRulesValidUntil.IsSet() {
		toSerialize["computingRulesValidUntil"] = o.ComputingRulesValidUntil.Get()
	}
	if o.PreferredCernLanguage.IsSet() {
		toSerialize["preferredCernLanguage"] = o.PreferredCernLanguage.Get()
	}
	if o.Telephone1.IsSet() {
		toSerialize["telephone1"] = o.Telephone1.Get()
	}
	if o.Telephone2.IsSet() {
		toSerialize["telephone2"] = o.Telephone2.Get()
	}
	if o.PortablePhone.IsSet() {
		toSerialize["portablePhone"] = o.PortablePhone.Get()
	}
	if o.EdhAuthPwdExpiry.IsSet() {
		toSerialize["edhAuthPwdExpiry"] = o.EdhAuthPwdExpiry.Get()
	}
	if o.EduPersonUniqueID.IsSet() {
		toSerialize["eduPersonUniqueID"] = o.EduPersonUniqueID.Get()
	}
	if o.Orcid.IsSet() {
		toSerialize["orcid"] = o.Orcid.Get()
	}
	if o.Description.IsSet() {
		toSerialize["description"] = o.Description.Get()
	}
	if o.HrEmail.IsSet() {
		toSerialize["hrEmail"] = o.HrEmail.Get()
	}
	if !IsNil(o.AtCern) {
		toSerialize["atCern"] = o.AtCern
	}
	if o.PostOfficeBox.IsSet() {
		toSerialize["postOfficeBox"] = o.PostOfficeBox.Get()
	}
	if !IsNil(o.Supervisor) {
		toSerialize["supervisor"] = o.Supervisor
	}
	if o.ExternalEmail.IsSet() {
		toSerialize["externalEmail"] = o.ExternalEmail.Get()
	}
	if o.PrimaryAccountEmail.IsSet() {
		toSerialize["primaryAccountEmail"] = o.PrimaryAccountEmail.Get()
	}
	if !IsNil(o.ResourceCategory) {
		toSerialize["resourceCategory"] = o.ResourceCategory
	}
	if !IsNil(o.Reassignable) {
		toSerialize["reassignable"] = o.Reassignable
	}
	if !IsNil(o.AutoReassign) {
		toSerialize["autoReassign"] = o.AutoReassign
	}
	if !IsNil(o.PendingAction) {
		toSerialize["pendingAction"] = o.PendingAction
	}
	if !IsNil(o.Disabled) {
		toSerialize["disabled"] = o.Disabled
	}
	if !IsNil(o.Blocked) {
		toSerialize["blocked"] = o.Blocked
	}
	if !IsNil(o.SecurityIssues) {
		toSerialize["securityIssues"] = o.SecurityIssues
	}
	if o.BlockingReason.IsSet() {
		toSerialize["blockingReason"] = o.BlockingReason.Get()
	}
	if o.BlockingTime.IsSet() {
		toSerialize["blockingTime"] = o.BlockingTime.Get()
	}
	if o.BlockingDeadline.IsSet() {
		toSerialize["blockingDeadline"] = o.BlockingDeadline.Get()
	}
	if o.ArchiveDeadline.IsSet() {
		toSerialize["archiveDeadline"] = o.ArchiveDeadline.Get()
	}
	if o.DeleteDeadline.IsSet() {
		toSerialize["deleteDeadline"] = o.DeleteDeadline.Get()
	}
	if o.ExpirationDeadline.IsSet() {
		toSerialize["expirationDeadline"] = o.ExpirationDeadline.Get()
	}
	if o.OwnerId.IsSet() {
		toSerialize["ownerId"] = o.OwnerId.Get()
	}
	if !IsNil(o.InternalState) {
		toSerialize["internalState"] = o.InternalState
	}
	if !IsNil(o.State) {
		toSerialize["state"] = o.State
	}
	if o.LastStateChangeTime.IsSet() {
		toSerialize["lastStateChangeTime"] = o.LastStateChangeTime.Get()
	}
	if o.ValidityLimit.IsSet() {
		toSerialize["validityLimit"] = o.ValidityLimit.Get()
	}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if !IsNil(o.CreationTime) {
		toSerialize["creationTime"] = o.CreationTime
	}
	return toSerialize, nil
}

func (o *Identity) UnmarshalJSON(data []byte) (err error) {
	// This validates that all required properties are included in the JSON object
	// by unmarshalling the object into a generic map with string keys and checking
	// that every required field exists as a key in the generic map.
	requiredProperties := []string{
		"type",
		"displayName",
		"unconfirmed",
	}

	allProperties := make(map[string]interface{})

	err = json.Unmarshal(data, &allProperties)

	if err != nil {
		return err
	}

	for _, requiredProperty := range requiredProperties {
		if _, exists := allProperties[requiredProperty]; !exists {
			return fmt.Errorf("no value given for required property %v", requiredProperty)
		}
	}

	varIdentity := _Identity{}

	decoder := json.NewDecoder(bytes.NewReader(data))
	decoder.DisallowUnknownFields()
	err = decoder.Decode(&varIdentity)

	if err != nil {
		return err
	}

	*o = Identity(varIdentity)

	return err
}

type NullableIdentity struct {
	value *Identity
	isSet bool
}

func (v NullableIdentity) Get() *Identity {
	return v.value
}

func (v *NullableIdentity) Set(val *Identity) {
	v.value = val
	v.isSet = true
}

func (v NullableIdentity) IsSet() bool {
	return v.isSet
}

func (v *NullableIdentity) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableIdentity(val *Identity) *NullableIdentity {
	return &NullableIdentity{value: val, isSet: true}
}

func (v NullableIdentity) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableIdentity) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
